<?php
//////////////////////////////////////////////////////////////////////
// CAT v2.0.0, March 13, 2002
// by:  Mike Agar
//      www.jmagar.com
//////////////////////////////////////////////////////////////////////
// This code is released under GPL refer to the included license.txt
//////////////////////////////////////////////////////////////////////

class agar_cat {
	var $cat_debug;
	var $cat_table_name;

//STATE MACHINE VARIABLES

/*********************************************************************************************
*** THIS MUST BE CALLED BEFORE ANY OTHER CAT FUNCTION !!!  ***********************************
**********************************************************************************************
	Required: Sets the database table name (pretty important)
	Optional: debug

*/
	function CAT_INIT($tableNamePrefix="AGAR_cat",$dbg=0){
		$this->cat_table_name=$tableNamePrefix; //MUST BE FIRST!!!
		$this->cat_debug = $dbg;
		
		//check to see if this table exisits... if not, create it.
		$result = mysql_query("show tables");
		while(list($name) = mysql_fetch_row($result)){
			//if($this->cat_debug)echo "CAT: $name =?= $this->cat_table_name<br>\n";
			if(strcmp($name,$this->cat_table_name)==0){
				if($this->cat_debug)echo "CAT: is already Installed<br>\n";
				return;
			}
		}
		if($this->cat_debug)echo "CAT: Table NOT Found, need to build it!<br>\n";
		$this->createCATTables();
	}


	function addCAT($title){
		$sd = $this->getCID($title);
		if(!$sd){
			$result = mysql_query("insert into $this->cat_table_name values(NULL,'$title')");
			$sd = mysql_insert_id();
		}
		return $sd;
	}

	function getCID($title){
		$result = mysql_query("select cid from $this->cat_table_name where title='$title'");
		if(mysql_num_rows($result)>0){
			list($sd) = mysql_fetch_row($result);
		}else{
			if($this->cat_debug)echo "CAT: getCID() - URL is not in the DB<br>\n";
			$sd=0;
		}
		return $sd;
	}

	function getCAT($cid){
		$result = mysql_query("select title from $this->cat_table_name where cid='$cid'");
		if(mysql_num_rows($result)>0){
			list($rtn) = mysql_fetch_row($result);
		}else{
			if($this->cat_debug)echo "CAT: getURL() - CID is not in the DB<br>\n";
			$rtn="";
		}
		return $rtn;
	}



/*******************************************************************************************
*** Admin Database Functions
*******************************************************************************************/
	function createCATTables(){
	//Master CAT Table
		$cmd =  "CREATE TABLE $this->cat_table_name (";
		$cmd .= "  cid int(11) DEFAULT '1' NOT NULL auto_increment,";
		$cmd .= "  title varchar(250) DEFAULT '' NOT NULL,";
		$cmd .= "  PRIMARY KEY (cid)";
		$cmd .= ")";
  		$err = mysql_query($cmd);
		$cmd =  "CREATE INDEX $this->cat_table_name"."_idx ON $this->cat_table_name (";
		$cmd .= "  title (15)";
		$cmd .= ")";
	  	$err = mysql_query($cmd);

	}

	function dropCATTables(){
		$err = mysql_query("drop index $this->cat_table_name"."_idx on $this->cat_table_name");
  		$err = mysql_query("drop table $this->cat_table_name");
	}

}



?>