<?php
//////////////////////////////////////////////////////////////////////
// SRC v2.0.0, March 13, 2002
// by:  Mike Agar
//      www.jmagar.com
//////////////////////////////////////////////////////////////////////
// This code is released under GPL refer to the included license.txt
//////////////////////////////////////////////////////////////////////
class SRC_ITEM {
	var $title;
	var $url;
	var $desc;
	var $timeout;
}

class agar_src {
	var $src_debug;
	var $src_table_name;

//STATE MACHINE VARIABLES

/*********************************************************************************************
*** THIS MUST BE CALLED BEFORE ANY OTHER SRC FUNCTION !!!  ***********************************
**********************************************************************************************
	Required: Sets the database table name (pretty important)
	Optional: debug

*/
	function SRC_INIT($tableNamePrefix="AGAR_src",$dbg=0){
		$this->src_table_name=$tableNamePrefix; //MUST BE FIRST!!!
		$this->src_debug = $dbg;
		
		//check to see if this table exisits... if not, create it.
		$result = mysql_query("show tables");
		while(list($name) = mysql_fetch_row($result)){
			//if($this->src_debug)echo "SRC: $name =?= $this->src_table_name<br>\n";
			if(strcmp($name,$this->src_table_name)==0){
				if($this->src_debug)echo "SRC: is already Installed<br>\n";
				return;
			}
		}
		if($this->src_debug)echo "SRC: Table NOT Found, need to build it!<br>\n";
		$this->createSRCTables();
	}

	function scrubURL($dirty){
		//TODO: come back here and parse URL to make them more uniform in the
		//      DB.  This should help reduce duplicates...
		return $dirty;
	}

	function addSRC($title,$comment,$dirty_url,$timeout=4000){
		$url = $this->scrubURL($dirty_url);
		$sd = $this->getSID($url);
		if(!$sd){
			$image = "";
			$result = mysql_query("insert into $this->src_table_name values(NULL,'$url','$title','$comment','$image',$timeout,$timeout,0)");
			$sd = mysql_insert_id();
		}
		return $sd;
	}

	function getSID($url){
		$result = mysql_query("select sid from $this->src_table_name where url='$url'");
		if(mysql_num_rows($result)>0){
			list($sd) = mysql_fetch_row($result);
		}else{
			if($this->src_debug)echo "SRC: getSID() - URL is not in the DB<br>\n";
			$sd=0;
		}
		return $sd;
	}

	function getURL($sd){
		$result = mysql_query("select url from $this->src_table_name where sid='$sd'");
		if(mysql_num_rows($result)>0){
			list($rtn) = mysql_fetch_row($result);
		}else{
			if($this->src_debug)echo "SRC: getURL() - SID is not in the DB<br>\n";
			$rtn="";
		}
		return $rtn;
	}

	function getTitle($sd){
		$result = mysql_query("select title from $this->src_table_name where sid='$sd'");
		if(mysql_num_rows($result)>0){
			list($rtn) = mysql_fetch_row($result);
		}else{
			if($this->src_debug)echo "SRC: getTitle() - SID ($sd) is not in the DB<br>\n";
			$rtn="";
		}
		return $rtn;
	}
	function getTimeout($sd){
		$result = mysql_query("select timeout from $this->src_table_name where sid='$sd'");
		if(mysql_num_rows($result)>0){
			list($rtn) = mysql_fetch_row($result);
		}else{
			if($this->src_debug)echo "SRC: getTimeout() - SID ($sd) is not in the DB<br>\n";
			$rtn="";
		}
		return $rtn;
	}

	function getSubscribers($sd){
		$result = mysql_query("select subscribers from $this->src_table_name where sid='$sd'");
		if(mysql_num_rows($result)>0){
			list($rtn) = mysql_fetch_row($result);
		}else{
			if($this->src_debug)echo "SRC: getSubscribers() - SID ($sd) is not in the DB<br>\n";
			$rtn="";
		}
		return $rtn;
	}

	function getComment($sd){
		$result = mysql_query("select comment from $this->src_table_name where sid='$sd'");
		if(mysql_num_rows($result)>0){
			list($rtn) = mysql_fetch_row($result);
		}else{
			if($this->src_debug)echo "SRC: getComment() - SID is not in the DB<br>\n";
			$rtn="";
		}
		return $rtn;
	}

	function getImage($sd){
		$result = mysql_query("select image from $this->src_table_name where sid='$sd'");
		if(mysql_num_rows($result)>0){
			list($rtn) = mysql_fetch_row($result);
		}else{
			if($this->src_debug)echo "SRC: getImage() - SID is not in the DB<br>\n";
			$rtn="SID = $sd is not found in the DB, thus no Image<br>\n";
		}
		return $rtn;
	}

	function incSubscribers($sd){
		$result = mysql_query("select subscribers from $this->src_table_name where sid='$sd'");
		if(mysql_num_rows($result)>0){
			list($rtn) = mysql_fetch_row($result);
		}else{
			if($this->src_debug)echo "SRC: incSubscribers() - SID is not in the DB<br>\n";
			$rtn=0;
		}
		if($rtn>=0){
			$rtn+=1;
			$result = mysql_query("UPDATE $this->src_table_name set subscribers='$rtn' where sid='$sd'");
		}
		return $rtn;
	}

	//TODO: TopX subscribers (search returns array ordered by top subscribers)

	function decSubscribers($sd){
		$result = mysql_query("select subscribers from $this->src_table_name where sid='$sd'");
		if(mysql_num_rows($result)>0){
			list($rtn) = mysql_fetch_row($result);
		}else{
			if($this->src_debug)echo "SRC: incSubscribers() - SID is not in the DB<br>\n";
			$rtn=0;
		}
		if($rtn>0){
			$rtn-=1;
			$result = mysql_query("UPDATE $this->src_table_name set subscribers='$rtn' where sid='$sd'");
		}
		return $rtn;
	}

	function resetSubscribers($sd){
		$result = mysql_query("UPDATE $this->src_table_name set subscribers='0' where sid='$sd'");
	}

	function setURL($sd,$input){
		$result = mysql_query("UPDATE $this->src_table_name set url='$input' where sid='$sd'");
	}

	function setTitle($sd,$input){
		$result = mysql_query("UPDATE $this->src_table_name set title='$input' where sid='$sd'");
	}

	function setImage($sd,$input){
		$result = mysql_query("UPDATE $this->src_table_name set image='$input' where sid='$sd'");
	}


	function setComment($sd,$url){
		$result = mysql_query("UPDATE $this->src_table_name set comment='$input' where sid='$sd'");
	}

	function setTimout($sd,$to){
		$result = mysql_query("UPDATE $this->src_table_name set timeout='$to' where sid='$sd'");
	}

	function delSID($sd){
		$result = mysql_query("delete from $this->src_table_name where sid='$sd'");
	}

//////////////////////////////////////////////////////////////////////////////////////////////////
//Timeouts Functions

	function isStale($sd){
		$rtn=0;
		$result = mysql_query("select lastupdate, timeout from $this->src_table_name where sid='$sd'");
		if(mysql_num_rows($result)>0){
			list($lu,$to) = mysql_fetch_row($result);
			$now= time();
			$stale = $now - ($lu+$to);
			if($stale>0)$rtn=1;
		}
		return $rtn;
	}

	function listStale(){
		//returns an array of stale sources, in order of subcribers.
		$now = time();
		$rtn = array();
		$query  = "SELECT sid";
		$query .= " FROM $this->src_table_name s";
		$query .= " WHERE s.subscribers > 0";
		$query .= " AND ($now - (s.lastupdate + s.timeout))>0";
		$query .= " ORDER BY s.subscribers desc";
		$result = mysql_query($query);
		if($result){
			if($this->src_debug)echo "listStale(): we may have one...<br>\n";
			if(mysql_num_rows($result)>0){
				while(list($sd)=mysql_fetch_row($result)){
					if($this->src_debug)echo "listStale(): sid=$sd<br>\n";
					$rtn[] = $sd;					
				}
			}
		}
		return $rtn;
	}

	function subsCount(){
		$rtn = array();

		$query  = "SELECT sid, subscribers";
		$query .= " FROM $this->src_table_name s";
		$query .= " WHERE s.subscribers > 0";
		$query .= " ORDER BY s.subscribers desc";
		$result = mysql_query($query);
		
		if($result){
			if($this->src_debug)echo "subsCount(): we may have one...<br>\n";
			if(mysql_num_rows($result)>0){
				while(list($sd,$count)=mysql_fetch_row($result)){
					if($this->src_debug)echo "listStale(): sid=$sd<br>\n";
					$rtn[$sd] = $count;					
				}
			}
		}
		return $rtn;
	}

	function srcCount(){
		$rtn = 0;

		$query  = "SELECT sid";
		$query .= " FROM $this->src_table_name s";
		$result = mysql_query($query);
		
		if($result){
			if($this->src_debug)echo "srcCount(): we may have one...<br>\n";
			$rtn = mysql_num_rows($result);
		}
		return $rtn;
	}

	function untouchAll(){//set all to "expired"
		$result = mysql_query("update $this->src_table_name set lastupdate='1'");
	}

	function touch($sd){//this is NOT expired
		$now = time();
		$result = mysql_query("update $this->src_table_name set lastupdate='$now' where sid='$sd'");
	}

	function untouch($sd){//this is expired
		$now = time();
		$result = mysql_query("update $this->src_table_name set lastupdate='1' where sid='$sd'");
	}

	function setTimeout($sd,$timeout){
		$result = mysql_query("UPDATE $this->src_table_name set timeout='$timeout' where sid='$sd'");
	}


/*******************************************************************************************
*** Admin Database Functions
*******************************************************************************************/
	function createSRCTables(){
	//Master SRC Table
		$cmd =  "CREATE TABLE $this->src_table_name (";
		$cmd .= "  sid int(11) DEFAULT '1' NOT NULL auto_increment,";
		$cmd .= "  url blob DEFAULT '' NOT NULL,";
		$cmd .= "  title blob DEFAULT '' NOT NULL,";
		$cmd .= "  comment blob DEFAULT '' NOT NULL,";
		$cmd .= "  image varchar(250) DEFAULT '' NOT NULL,";
		$cmd .= "  timeout int(11) NOT NULL,";
		$cmd .= "  lastupdate int(11) NOT NULL,";
		$cmd .= "  subscribers int(11) NOT NULL,";
		$cmd .= "  PRIMARY KEY (sid)";
		$cmd .= ")";
  	$err = mysql_query($cmd);
		$cmd =  "CREATE INDEX $this->src_table_name"."_idx ON $this->src_table_name (";
		$cmd .= "  url (15)";
		$cmd .= ")";
  	$err = mysql_query($cmd);

	}

	function dropSRCTables(){
		$err = mysql_query("drop index $this->src_table_name"."_idx on $this->src_table_name");
  	$err = mysql_query("drop table $this->src_table_name");
	}

}
?>