<?php
//////////////////////////////////////////////////////////////////////
// MyHeadlines v4.0.0, March 13, 2002
// by:  Mike Agar
//      www.jmagar.com
//////////////////////////////////////////////////////////////////////
// This code is released under GPL refer to the included license.txt
//////////////////////////////////////////////////////////////////////

class myh_install {
	var $debug;

	function myhRegister($myh_pd,$vers){
		$myh_pd->setValue("Version",$vers);
		$myh_pd->setValue("close_table","</td></tr><tr height=100%><td width=100% align=\"right\" valign=\"bottom\"><sub><a href=http://www.jmagar.com>MyHeadlines</a> v".$vers." by Mike Agar</sub></td></tr></table>\n");
		$myh_pd->setValue("front_page","<center><h2>MyHeadlines v".$vers."</h2>by Mike Agar<br><a href=http://www.jmagar.com>www.jmagar.com</a></center>\n");
		$buttonCode = "
						\$myh_form_start = \"<table border=0 width=100%><tr><td>\";
						if(\$this->MYH_DEBUG){
							\$myh_form_start .= \"<form action=\".\$this->prefixURL.\" method=get>\n\";
						}else{
							\$myh_form_start .= \"<form action=\".\$this->prefixURL.\" method=post>\n\";
						}
						\$myh_form_start .= \$this->myhFormEnd(\$button);
						\$myh_form_start .= \$this->pd->getValue(\"close_table\");
						";
		$myh_pd->setValue("reset_button",$buttonCode);
		
	}
	
	function myhInstall_400($myh_pd){
		global $myhPath;
		if($this->debug) echo "Init<br>\n";
		$myh_pd->setValue("num_search_results_per_page",20);
		$myh_pd->setValue("max_updates_per_cron_cycle",20);
		$myh_pd->setValue("show_shameless_plug",0);
		$myh_pd->setValue("menu_initialized",0);
		$myh_pd->setValue("user_show_adm",0);
		$myh_pd->setValue("user_show_1",0);
		$myh_pd->setValue("show_shameless_plug",1);  //you can turn it off if you want.
		$myh_pd->setValue("allow_anonymous",1);
		$myh_pd->setValue("rss_pow_img","<a href=http://www.jmagar.com><img alt=MyHeadlines src=$myhPath/images/myh.gif border=0></a>");
		$myh_pd->setValue("rss_proxy_enabled",0);
		$myh_pd->setValue("rss_proxy_host",0);
		$myh_pd->setValue("rss_proxy_port",0);
		$myh_pd->setValue("rss_proxy_user",0);
		$myh_pd->setValue("rss_proxy_pass",0);
		$myh_pd->setValue("enable_center_blocks",1);
		$myh_pd->setValue("num_collumns",3);
		$myh_pd->setValue("stck_timeout",30);
		$myh_pd->setValue("rss_initialized",1);
		$myh_pd->setValue("rss_timeout",5);
		$myh_pd->setValue("rss_proxy_enabled",0);
		$myh_pd->setValue("rss_max_items",6);
		$myh_pd->setValue("rss_show_summary",0);
		$myh_pd->setValue("rss_logo_width",120);
		$myh_pd->setValue("rss_override_logo_width",1);
		$myh_pd->setValue("rss_cache_expire","30");//days
		$myh_pd->setValue("consecutive_failures_before_bad",3);
	}
	
	function myhUpdate_400_401($myh_pd){
		if($this->debug)echo "Upgrade 4.0.0 -> 4.0.1 <br>\n";
		$this->UnInstall("_myh_cache");
	}

	function myhUpdate_401_402($myh_pd){
		if($this->debug)echo "Upgrade 4.0.1 -> 4.0.2 <br>\n";
		//changed RSS_ITEM class, invalidating all cached items... (remove the cache and re-install)
		$this->UnInstall("_myh_cache");
		//Now you can change the date format...
		$myh_pd->setValue("date_format","m/d");
	}

	function myhUpdate_402_403($myh_pd){
		if($this->debug)echo "Upgrade 4.0.2 -> 4.0.3 <br>\n";
		//Restored RSS_ITEM class to v4.0.1 state.  (this pooched the cache object...)
		$this->UnInstall("_myh_cache");
	}

	function myhUpdate_403_404($myh_pd){
		if($this->debug)echo "Upgrade 4.0.3 -> 4.0.4 <br>\n";
		//Adding Google Client API
		$myh_pd->setValue("google_registration_key",0);
	}
	
	function Install($myh_pd,$dbg=0){
		global $myhPath;
		
		$this->debug = $dbg;
		$myhVersion = "4.0.4";
		//Installation State Machine:  Incremental Updates!
		switch($myh_pd->getValue("Version")){
			case 0:
				$this->myhInstall_400($myh_pd);						
			case "4.0.0":
				$this->myhUpdate_400_401($myh_pd);
			case "4.0.1":
				$this->myhUpdate_401_402($myh_pd);
			case "4.0.2":
				$this->myhUpdate_402_403($myh_pd);
			case "4.0.3":
				$this->myhUpdate_403_404($myh_pd);
	/*************************************************************************************/
				$this->myhRegister($myh_pd,$myhVersion);
			case "$myhVersion":
				//no change...  Do nothing.
				break;
			default: //Unknown "Version" kill it all and rebuild
				//reset and re-install...
				if($this->debug)echo "INSTALL: New Version Detected - need to uninstall...<br>\n";
				$this->UnInstall();
				die("Please hit refresh to re-install");
		}
	}

	function UnInstall($tableName="_myh_"){
		$result = mysql_query("show tables");
		while(list($name) = mysql_fetch_row($result)){
			if(ereg($tableName,$name)){//pretty scary...
				if($this->debug)echo "INSTALL: UNISTALLING = $name <br>\n";
			  	$err = mysql_query("drop table $name");
			}
		}
	
	}
}
?>