<?php
//////////////////////////////////////////////////////////////////////
// MyHeadlines v3.1.0, January 3, 2002
// by:  Mike Agar
//      myh_support@jmagar.com 
//      www.jmagar.com
//////////////////////////////////////////////////////////////////////
// This code is released under GPL refer to the included license.txt
//////////////////////////////////////////////////////////////////////

/**** found in stck.php ****************
class STCK_ITEM {
	var $alias;
	var $symbol;
	var $value;
	var $change;
}
****************************************/

class myh_stock {
	
	////////////////////////////////////////////////////////////////////////
	////////////////////////////////////////////////////////////////////////
	////////////////////////////////////////////////////////////////////////
	// init defaults
	function myh_stock($myh_pd){	
		if(!$myh_pd->getValue("stck_initialized")){
			//init stock
			$myh_pd->setValue("stck_initialized",1);
			$myh_pd->setValue("stck_timeout",30); //minutes
		}
	}

	function updateStckInfo($myh_pd, $sInfo){
		$url  = "http://finance.yahoo.com/q?s=";
		$url .= $sInfo->symbol;
	
		$page = myh_rss::getFileFromURL($myh_pd,$url);

		$out = new STCK_ITEM;
		$out->alias   = $sInfo->alias;
		$out->symbol  = $sInfo->symbol;
		$scp = new agar_scraper();
		if(strlen($page)>15){
			$preArray = array();
			$preArray[] = "Last Trade";
			$preArray[] = "href";
			$preArray[] = "nowrap";
			$out->value   = $scp->scrape($preArray,"./td.","./td.",$page);
			$preArray[] = "nowrap";
			$out->change  = $scp->scrape($preArray,"./td.","./td.",$page);
		}else{
			//error...
			$out->value   = "<td>???";
			$out->change  = "<td>???";
		}
	
		return $out;
	}
	
	
	function updateStockCache($myh_pd, $myh_stck, $myhLang, $sd){	
		//go get this src's file...
		$sInfo = $myh_stck->getStckInfo($sd);
		$sInfo = $this->updateStckInfo($myh_pd,$sInfo);
		$myh_stck->setStckInfo($sd,$sInfo);
	}
	
	
	function getStockCache($myh_pd,$myh_stck,$myhLang,$sd){
		global $myhURL;
	
		if($myh_stck->isStale($sd))$this->updateStockCache($myh_pd,$myh_stck,$myhLang,$sd);
		return $myh_stck->getStckInfo($sd);	
	
	}
	
	function myhStockBox($myh_pd,$myh_stck,$myhLang,$subs,$myhURL){//subs is an array of stck id's
	
		$end = count($subs);
		$content="";
		if($end>0){
			//begin table
			if($myh_pd->getValue("rss_override_logo_width")){
				$maxWidth = $myh_pd->getValue("rss_logo_width");
			}else{
				$maxWidth = "100%";
			}
			$content .= "<table width=$maxWidth border=1><tr><td></td><td align=center>".$myhLang["change"]."</td><td align=center>".$myhLang["last"]."</td></tr>\n";
			//fill table
			for($loop=0;$loop<$end;$loop++){
				$sInfo = $this->getStockCache($myh_pd,$myh_stck,$myhLang,$subs[$loop]);
				$sURL  = "<a href=http://finance.yahoo.com/q?s=";
				$sURL .= $sInfo->symbol."&d=t target=sinfo>";
				$content .= "<tr><td width=100% align=left>".$sURL.$sInfo->alias."</a></td>";
				$content .= $sInfo->change."</td>";
				$content .= $sInfo->value."</td></tr>\n";
			}
			//end table
			$content .= "</table>\n";
		}	
		$content .= "<center><a href=$myhURL";
		$content .= $myh_pd->getValue("DL_add_stock");
		$content .= ">$myhLang[Add_New_Symbol]</a></center>";
	
		//prep the theme side block
		$box = array();
		$box["content"]=$content;
		$box["image"]="";
		$box["title"]=$myhLang["Place9"];
		return $box;
	}
}
?>