<?php
//////////////////////////////////////////////////////////////////////
// Scraper v2.0.0, March 19, 2002
// by:  Mike Agar
//      www.jmagar.com
//////////////////////////////////////////////////////////////////////
// This code is released under GPL refer to the included license.txt
//////////////////////////////////////////////////////////////////////

class agar_scraper {
	var $debug;
	var $NoError; //if error detected global to break out...

	function agar_scraper($dbg=0){
		$this->debug = $dbg;
	}

	function charSearch($val, $fp){
		if($this->debug)echo "CS(): ($val)";
		$newString = split($val,$fp,2);
		$cnt = @count($newString);
		if($cnt == 2){
			if($this->debug)echo "- found<br>\n";
			return $newString[1];
		}else{
			$this->NoError = 0;
			if($this->debug)echo "- not found<br>\n";
			return "";
		}
	}
	
	function finish($fp,$val){
		if($this->debug)echo "finish(): ($val)";
		$newString = split($val,$fp,2);
		$cnt = @count($newString);
		if($cnt == 2){
			if($this->debug)echo "- found<br>\n";
			return $newString[0];
		}else{
			$this->NoError = 0;
			if($this->debug)echo "- not found<br>\n";
			return "";
		}
	}
	
	
	function scrape($preArray, $start, $end, $page){
		global $myhScrapNoError;
	
		$this->NoError = 1; //all is fine
		$lend = count($preArray);
		$pagePtr = $page;
		for($arLoop=0;$arLoop<$lend;$arLoop++){
			$pagePtr = $this->charSearch($preArray[$arLoop],$pagePtr);
			if(!$this->NoError)$arLoop=$lend; //break out if not found
		}
		//finished searching for the preArray elements... verify success
		if($this->NoError){
		  //look for start delimiter
			if($this->NoError)$pagePtr = $this->charSearch($start,$pagePtr);
			if($this->NoError){
				//Start delimiter has been found...  scrape the text.
				$pagePtr = $this->finish($pagePtr,$end);
			}
		}
		if($this->NoError){
			return $pagePtr;
		}else{
			return "";
		}
	}
}
?>