<?php
//////////////////////////////////////////////////////////////////////
// MyHeadlines v4.0.0, March 15, 2002
// by:  Mike Agar
//      www.jmagar.com
//////////////////////////////////////////////////////////////////////
// This code is released under GPL refer to the included license.txt
//////////////////////////////////////////////////////////////////////

global $myh_CB_menu_items;

function myhMenuTreeCallBack($eid,$tid){
	global $myh_CB_menu_items;
	return $myh_CB_menu_items[$eid];
}



class myh_menu {
	var $MYH_DEBUG;
	var $myh_menu_items;
	var $myh_menu_types;
	var $myh_menu_file;
	var $myhURL;

	function myh_menu($myh_pd,$myh_gtu,$myhLang,$url,$dbg=0){
		$this->MYH_DEBUG = $dbg;
	
		$this->myh_menu_types = array();
		$this->myh_menu_items = array();
		$this->myh_menu_file = array();
		
		$this->myh_menu_types["admin"] 					= 200;
		$this->myh_menu_types["user"]  					= 300;
		
		$idx = 100; $this->myh_menu_items[$idx]	=	$myhLang["Admin"];			$this->myh_menu_file[$idx] = "admDefault.php";
		$idx = 101; $this->myh_menu_items[$idx]	=	$myhLang["Import"];			$this->myh_menu_file[$idx] = "admImport.php";
		$idx = 102; $this->myh_menu_items[$idx]	=	$myhLang["Maintenance"];	$this->myh_menu_file[$idx] = "admMaintenance.php";
		$idx = 103; $this->myh_menu_items[$idx]	=	$myhLang["Config"];			$this->myh_menu_file[$idx] = "admConfig.php";
		$idx = 104; $this->myh_menu_items[$idx]	=	$myhLang["User_Subs"];		$this->myh_menu_file[$idx] = "admUserSubs.php";
		$idx = 500; $this->myh_menu_items[$idx]	=	$myhLang["Unsubscribe"];	$this->myh_menu_file[$idx] = "usrSubs.php";
		$idx = 501; $this->myh_menu_items[$idx]	=	$myhLang["Subscribe"];		$this->myh_menu_file[$idx] = "usrSubscribe.php";
		$idx = 502; $this->myh_menu_items[$idx]	=	$myhLang["Submit"];			$this->myh_menu_file[$idx] = "usrSubmit.php";
		$idx = 503; $this->myh_menu_items[$idx]	=	$myhLang["Search"];			$this->myh_menu_file[$idx] = "usrSearch.php";
		$idx = 504; $this->myh_menu_items[$idx]	=	$myhLang["Recent"];			$this->myh_menu_file[$idx] = "usrRecent.php";
		$idx = 505; $this->myh_menu_items[$idx]	=	$myhLang["Place9"];			$this->myh_menu_file[$idx] = "usrNewStock.php";
		$idx = 506; $this->myh_menu_items[$idx]	=	$myhLang["TopTen"];			$this->myh_menu_file[$idx] = "usrStats.php";
	
		$this->INIT_URL_PREFIX($url);
		$this->INIT_CALLBACK();
				
		if(!$myh_pd->getValue("menu_initialized")){
			//init menus
			if($this->MYH_DEBUG)echo "MENUS: Initializing Menus<br>\n";
			$myh_pd->setValue("menu_initialized",1);
			$this->PRIVATE_MENU_INIT($myh_pd,$myh_gtu);
		}
	}
	
	function INIT_CALLBACK(){
		global $myh_CB_menu_items;
		$myh_CB_menu_items = $this->myh_menu_items;
	}

	function INIT_URL_PREFIX($url){
		$this->myhURL = $url;	
	}

	//TODO: build a graceful un-install function.
	
	
	
	function PRIVATE_MENU_INIT($myh_pd,$myh_gtu){
		//build menu tree
		$myh_gtu->GTU_SELECT("menu");
		$rid = $myh_gtu->c_rid;
//Build Admin Menu
		$adminID = $myh_gtu->addNode($rid,100,$this->myh_menu_types["admin"]);
		$gid = $myh_gtu->addNode($adminID,101,$this->myh_menu_types["admin"]);
		$gid = $myh_gtu->addNode($adminID,102,$this->myh_menu_types["admin"]);
		$gid = $myh_gtu->addNode($adminID,103,$this->myh_menu_types["admin"]);
		$gid = $myh_gtu->addNode($adminID,104,$this->myh_menu_types["admin"]);
//Build User Menu
		//subscribe link
		$sgid = $myh_gtu->addNode($rid,501,$this->myh_menu_types["user"]);
		$directLink  = "&myh=menu";
		$directLink .= "&gid=$sgid";
		$directLink .= "&pid=$rid";
		$directLink .= "&eid=501";
		$directLink .= "&tid=".$this->myh_menu_types["user"];
		$directLink .= "&context=:$sgid:";
		$myh_pd->setValue("DL_subscribe",$directLink);
		//un-subscribe link
		$gid = $myh_gtu->addNode($sgid,500,$this->myh_menu_types["user"]);
		$directLink  = "&myh=menu";
		$directLink .= "&gid=$gid";
		$directLink .= "&pid=$sgid";
		$directLink .= "&eid=500";
		$directLink .= "&tid=".$this->myh_menu_types["user"];
		$directLink .= "&context=:$sgid:";
		$myh_pd->setValue("DL_unsubscribe",$directLink);
		//Stock Ticker Menu Item
		$gid = $myh_gtu->addNode($sgid,505,$this->myh_menu_types["user"]);
		$directLink  = "&myh=menu";
		$directLink .= "&gid=$gid";
		$directLink .= "&pid=$sgid";
		$directLink .= "&eid=505";
		$directLink .= "&tid=".$this->myh_menu_types["user"];
		$directLink .= "&context=:$sgid:";
		$myh_pd->setValue("DL_add_stock",$directLink);
		//Search, latest, submit, top ten...
		$gid = $myh_gtu->addNode($rid,503,$this->myh_menu_types["user"]);
		$gid = $myh_gtu->addNode($rid,504,$this->myh_menu_types["user"]);
		$gid = $myh_gtu->addNode($rid,506,$this->myh_menu_types["user"]);
		$gid = $myh_gtu->addNode($rid,502,$this->myh_menu_types["user"]);
		//build states
		//BOTH
		$myh_gtu->GTU_SELECT("menu","both",0,0,0);
		$myh_gtu->setGetTextCallBack("myhMenuTreeCallBack");
		$this->setMenuView($myh_gtu,1,1);
		//admin only
		$myh_gtu->GTU_SELECT("menu","admin",0,0,0);
		$myh_gtu->setGetTextCallBack("myhMenuTreeCallBack");
		$this->setMenuView($myh_gtu,1,1);
		//user only
		$myh_gtu->GTU_SELECT("menu","user",0,0,0);
		$myh_gtu->setGetTextCallBack("myhMenuTreeCallBack");
		$this->setMenuView($myh_gtu,0,1);
	}

	function setMenuView(&$myh_gtu,$a,$u){
		if($this->MYH_DEBUG)$this->registerTID($myh_gtu,"DEBUG",1);
		$this->registerTID($myh_gtu,"admin",$a);
		$this->registerTID($myh_gtu,"user",$u);
	
	}

	function registerTID(&$myh_gtu,$name,$visible){
		//GTU Wrapper for menu items...
		$url = $this->myhURL."&myh=menu";
		$myh_gtu->setTypeID($this->myh_menu_types[$name]);
		$myh_gtu->setVisible($this->myh_menu_types[$name],$visible);
		$myh_gtu->setURL($this->myh_menu_types[$name],$url);
	}


	function showMenu($myh_gtu,$myh_act){
		global $context;
		$flag = "$myh_act->isAdmin"."$myh_act->isUser";
		if($this->MYH_DEBUG) echo "showMenu(): Flag = $flag <br>\n"; 
		switch($flag){
			case "10":
				$myh_gtu->GTU_SELECT("menu","admin",0,0,0);
				break;
			case "11":
				$myh_gtu->GTU_SELECT("menu","both",0,0,0);
				break;
			default:
				$myh_gtu->GTU_SELECT("menu","user",0,0,0);
				break;
		} 
		return $myh_gtu->drawContextTree(0,0,$context,1);
	}

	function getScreenCode(){
		global $myhPath;
		global $eid,$meid;
		if(isset($meid)){
			$idx = $meid;
		}else{
			$idx = $eid;
		}		
		$fname =  $myhPath."/screens/".$this->myh_menu_file[$idx];
		if($this->MYH_DEBUG) echo "showMenuScreen(): eid = $eid <br>\n"; 
		if($this->MYH_DEBUG) echo "showMenuScreen(): File = $fname<hr><br>\n";
		// get contents of a file into a string
		$fd = fopen ($fname, "r");
		$contents = fread ($fd, filesize ($fname));
		fclose ($fd);
		return $contents;
	}
}
?>